// 	$Id: consumer.hh,v 2.2 2004-11-18 15:16:16 pary Exp $
// Copyright (c) 2003,2004  Pavel Rychly

#ifndef FINLIB_CONSUMER_HH
#define FINLIB_CONSUMER_HH

#include <finlib/fstream.hh>
#include <string>

class TextConsumer {
protected:
    TextConsumer() {}
public:
    virtual ~TextConsumer() {}
    void operator() (int id) {this->put (id);}
    virtual void put (int id) =0;
    virtual Position curr_size() =0;

    typedef enum {tdelta, tdeltabig, tint, tdeltagiga} TextType;
    static TextConsumer* create (TextType tt, const std::string &path, 
				 bool append=false);
};


class RevFileConsumer {
protected:
    RevFileConsumer() {}
public:
    virtual ~RevFileConsumer() {}
    void operator() (int id, Position pos) {this->put (id, pos);}
    virtual void put (int id, Position pos) =0;

    static RevFileConsumer* create (const std::string &path, 
				    int buff_size=1048576, int align=1,
				    bool append=false);
};


void finish_rev_files (const std::string &outname, int num_of_files, 
		       int align);

#endif
